diff -uNr djbdns-1.05/FILES djbdns-1.05-new/FILES
--- djbdns-1.05/FILES	2001-02-11 16:11:45.000000000 -0500
+++ djbdns-1.05-new/FILES	2003-09-16 10:09:36.000000000 -0400
@@ -135,6 +135,7 @@
 exit.h
 fmt.h
 fmt_ulong.c
+fmt_xlong.c
 gen_alloc.h
 gen_allocdefs.h
 getln.c
@@ -151,6 +152,9 @@
 ip4.h
 ip4_fmt.c
 ip4_scan.c
+ip6.h
+ip6_fmt.c
+ip6_scan.c
 ndelay.h
 ndelay_off.c
 ndelay_on.c
@@ -164,6 +168,7 @@
 readclose.c
 readclose.h
 scan.h
+scan_0x.c
 scan_ulong.c
 seek.h
 seek_set.c
@@ -241,3 +246,9 @@
 warn-shsgr
 buffer_read.c
 buffer_write.c
+dns_nd6.c
+socket_udp6.c
+socket_getifidx.c
+tryn2i.c
+haven2i.h1
+haven2i.h2
diff -uNr djbdns-1.05/Makefile djbdns-1.05-new/Makefile
--- djbdns-1.05/Makefile	2001-02-11 16:11:45.000000000 -0500
+++ djbdns-1.05-new/Makefile	2003-09-16 10:09:36.000000000 -0400
@@ -120,12 +120,14 @@
 case_diffb.o case_diffs.o case_lowerb.o fmt_ulong.o ip4_fmt.o \
 ip4_scan.o scan_ulong.o str_chr.o str_diff.o str_len.o str_rchr.o \
 str_start.o uint16_pack.o uint16_unpack.o uint32_pack.o \
-uint32_unpack.o
+uint32_unpack.o ip6_fmt.o ip6_scan.o fmt_xlong.o \
+scan_xlong.o
 	./makelib byte.a byte_chr.o byte_copy.o byte_cr.o \
 	byte_diff.o byte_zero.o case_diffb.o case_diffs.o \
 	case_lowerb.o fmt_ulong.o ip4_fmt.o ip4_scan.o scan_ulong.o \
 	str_chr.o str_diff.o str_len.o str_rchr.o str_start.o \
-	uint16_pack.o uint16_unpack.o uint32_pack.o uint32_unpack.o
+	uint16_pack.o uint16_unpack.o uint32_pack.o uint32_unpack.o \
+	ip6_fmt.o ip6_scan.o fmt_xlong.o scan_xlong.o
 
 byte_chr.o: \
 compile byte_chr.c byte.h
@@ -228,11 +230,13 @@
 dns.a: \
 makelib dns_dfd.o dns_domain.o dns_dtda.o dns_ip.o dns_ipq.o dns_mx.o \
 dns_name.o dns_nd.o dns_packet.o dns_random.o dns_rcip.o dns_rcrw.o \
-dns_resolve.o dns_sortip.o dns_transmit.o dns_txt.o
+dns_resolve.o dns_sortip.o dns_transmit.o dns_txt.o dns_ip6.o \
+dns_sortip6.o dns_nd6.o dns_ipq6.o
 	./makelib dns.a dns_dfd.o dns_domain.o dns_dtda.o dns_ip.o \
 	dns_ipq.o dns_mx.o dns_name.o dns_nd.o dns_packet.o \
 	dns_random.o dns_rcip.o dns_rcrw.o dns_resolve.o \
-	dns_sortip.o dns_transmit.o dns_txt.o
+	dns_sortip.o dns_transmit.o dns_txt.o dns_ip6.o dns_sortip6.o \
+	dns_nd6.o dns_ipq6.o
 
 dns_dfd.o: \
 compile dns_dfd.c error.h alloc.h byte.h dns.h stralloc.h gen_alloc.h \
@@ -254,11 +258,21 @@
 stralloc.h iopause.h taia.h tai.h uint64.h taia.h
 	./compile dns_ip.c
 
+dns_ip6.o: \
+compile dns_ip6.c stralloc.h gen_alloc.h uint16.h byte.h dns.h \
+stralloc.h iopause.h taia.h tai.h uint64.h taia.h
+	./compile dns_ip6.c
+
 dns_ipq.o: \
 compile dns_ipq.c stralloc.h gen_alloc.h case.h byte.h str.h dns.h \
 stralloc.h iopause.h taia.h tai.h uint64.h taia.h
 	./compile dns_ipq.c
 
+dns_ipq6.o: \
+compile dns_ipq6.c stralloc.h gen_alloc.h case.h byte.h str.h dns.h \
+stralloc.h iopause.h taia.h tai.h uint64.h taia.h
+	./compile dns_ipq6.c
+
 dns_mx.o: \
 compile dns_mx.c stralloc.h gen_alloc.h byte.h uint16.h dns.h \
 stralloc.h iopause.h taia.h tai.h uint64.h taia.h
@@ -274,6 +288,11 @@
 taia.h tai.h uint64.h taia.h
 	./compile dns_nd.c
 
+dns_nd6.o: \
+compile dns_nd6.c byte.h fmt.h dns.h stralloc.h gen_alloc.h iopause.h \
+taia.h tai.h uint64.h taia.h
+	./compile dns_nd6.c
+
 dns_packet.o: \
 compile dns_packet.c error.h dns.h stralloc.h gen_alloc.h iopause.h \
 taia.h tai.h uint64.h taia.h
@@ -306,6 +325,11 @@
 taia.h tai.h uint64.h taia.h
 	./compile dns_sortip.c
 
+dns_sortip6.o: \
+compile dns_sortip6.c byte.h dns.h stralloc.h gen_alloc.h iopause.h \
+taia.h tai.h uint64.h taia.h
+	./compile dns_sortip6.c
+
 dns_transmit.o: \
 compile dns_transmit.c socket.h uint16.h alloc.h error.h byte.h \
 uint16.h dns.h stralloc.h gen_alloc.h iopause.h taia.h tai.h uint64.h \
@@ -369,6 +393,17 @@
 gen_alloc.h iopause.h taia.h tai.h uint64.h taia.h
 	./compile dnsip.c
 
+dnsip6: \
+load dnsip6.o iopause.o dns.a env.a libtai.a alloc.a buffer.a unix.a \
+byte.a socket.lib
+	./load dnsip6 iopause.o dns.a env.a libtai.a alloc.a \
+	buffer.a unix.a byte.a  `cat socket.lib`
+
+dnsip6.o: \
+compile dnsip6.c buffer.h exit.h strerr.h ip6.h dns.h stralloc.h \
+gen_alloc.h iopause.h taia.h tai.h uint64.h
+	./compile dnsip6.c
+
 dnsipq: \
 load dnsipq.o iopause.o dns.a env.a libtai.a alloc.a buffer.a unix.a \
 byte.a socket.lib
@@ -380,6 +415,17 @@
 gen_alloc.h iopause.h taia.h tai.h uint64.h taia.h
 	./compile dnsipq.c
 
+dnsip6q: \
+load dnsip6q.o iopause.o dns.a env.a libtai.a alloc.a buffer.a unix.a \
+byte.a socket.lib
+	./load dnsip6q iopause.o dns.a env.a libtai.a alloc.a \
+	buffer.a unix.a byte.a  `cat socket.lib`
+
+dnsip6q.o: \
+compile dnsip6q.c buffer.h exit.h strerr.h ip4.h dns.h stralloc.h \
+gen_alloc.h iopause.h taia.h tai.h uint64.h taia.h
+	./compile dnsip6q.c
+
 dnsmx: \
 load dnsmx.o iopause.o dns.a env.a libtai.a alloc.a buffer.a unix.a \
 byte.a socket.lib
@@ -399,7 +445,7 @@
 
 dnsname.o: \
 compile dnsname.c buffer.h exit.h strerr.h ip4.h dns.h stralloc.h \
-gen_alloc.h iopause.h taia.h tai.h uint64.h taia.h
+gen_alloc.h iopause.h taia.h tai.h uint64.h taia.h ip6.h
 	./compile dnsname.c
 
 dnsq: \
@@ -484,6 +530,10 @@
 compile fmt_ulong.c fmt.h
 	./compile fmt_ulong.c
 
+fmt_xlong.o: \
+compile fmt_xlong.c scan.h
+	./compile fmt_xlong.c
+
 generic-conf.o: \
 compile generic-conf.c strerr.h buffer.h open.h generic-conf.h \
 buffer.h
@@ -546,10 +596,18 @@
 compile ip4_fmt.c fmt.h ip4.h
 	./compile ip4_fmt.c
 
+ip6_fmt.o: \
+compile ip6_fmt.c fmt.h ip6.h
+	./compile ip6_fmt.c
+
 ip4_scan.o: \
 compile ip4_scan.c scan.h ip4.h
 	./compile ip4_scan.c
 
+ip6_scan.o: \
+compile ip6_scan.c scan.h ip6.h
+	./compile ip6_scan.c
+
 it: \
 prog install instcheck
 
@@ -626,9 +684,9 @@
 	./compile parsetype.c
 
 pickdns: \
-load pickdns.o server.o response.o droproot.o qlog.o prot.o dns.a \
+load pickdns.o server.o iopause.o response.o droproot.o qlog.o prot.o dns.a \
 env.a libtai.a cdb.a alloc.a buffer.a unix.a byte.a socket.lib
-	./load pickdns server.o response.o droproot.o qlog.o \
+	./load pickdns server.o iopause.o response.o droproot.o qlog.o \
 	prot.o dns.a env.a libtai.a cdb.a alloc.a buffer.a unix.a \
 	byte.a  `cat socket.lib`
 
@@ -677,7 +735,7 @@
 rbldns-data pickdns-conf pickdns pickdns-data tinydns-conf tinydns \
 tinydns-data tinydns-get tinydns-edit axfr-get axfrdns-conf axfrdns \
 dnsip dnsipq dnsname dnstxt dnsmx dnsfilter random-ip dnsqr dnsq \
-dnstrace dnstracesort cachetest utime rts
+dnstrace dnstracesort cachetest utime rts dnsip6 dnsip6q
 
 prot.o: \
 compile prot.c hasshsgr.h prot.h
@@ -704,9 +762,9 @@
 	./compile random-ip.c
 
 rbldns: \
-load rbldns.o server.o response.o dd.o droproot.o qlog.o prot.o dns.a \
+load rbldns.o server.o iopause.o response.o dd.o droproot.o qlog.o prot.o dns.a \
 env.a libtai.a cdb.a alloc.a buffer.a unix.a byte.a socket.lib
-	./load rbldns server.o response.o dd.o droproot.o qlog.o \
+	./load rbldns server.o iopause.o response.o dd.o droproot.o qlog.o \
 	prot.o dns.a env.a libtai.a cdb.a alloc.a buffer.a unix.a \
 	byte.a  `cat socket.lib`
 
@@ -762,6 +820,10 @@
 compile scan_ulong.c scan.h
 	./compile scan_ulong.c
 
+scan_xlong.o: \
+compile scan_xlong.c scan.h
+	./compile scan_xlong.c
+
 seek_set.o: \
 compile seek_set.c seek.h
 	./compile seek_set.c
@@ -774,7 +836,7 @@
 compile server.c byte.h case.h env.h buffer.h strerr.h ip4.h uint16.h \
 ndelay.h socket.h uint16.h droproot.h qlog.h uint16.h response.h \
 uint32.h dns.h stralloc.h gen_alloc.h iopause.h taia.h tai.h uint64.h \
-taia.h
+taia.h iopause.h alloc.h str.h
 	./compile server.c
 
 setup: \
@@ -796,14 +858,26 @@
 compile socket_accept.c byte.h socket.h uint16.h
 	./compile socket_accept.c
 
+socket_accept6.o: \
+compile socket_accept6.c byte.h socket.h uint16.h
+	./compile socket_accept6.c
+
 socket_bind.o: \
 compile socket_bind.c byte.h socket.h uint16.h
 	./compile socket_bind.c
 
+socket_bind6.o: \
+compile socket_bind6.c sockaddr_in6.h haveip6.h byte.h socket.h uint16.h uint32.h ip6.h error.h
+	./compile socket_bind6.c
+
 socket_conn.o: \
 compile socket_conn.c byte.h socket.h uint16.h
 	./compile socket_conn.c
 
+socket_connect6.o: \
+compile socket_connect6.c byte.h socket.h uint16.h uint32.h
+	./compile socket_connect6.c
+
 socket_listen.o: \
 compile socket_listen.c socket.h uint16.h
 	./compile socket_listen.c
@@ -812,18 +886,47 @@
 compile socket_recv.c byte.h socket.h uint16.h
 	./compile socket_recv.c
 
+socket_recv6.o: \
+compile socket_recv6.c sockaddr_in6.h haveip6.h byte.h socket.h uint16.h uint32.h ip6.h error.h
+	./compile socket_recv6.c
+
 socket_send.o: \
 compile socket_send.c byte.h socket.h uint16.h
 	./compile socket_send.c
 
+socket_send6.o: \
+compile socket_send6.c byte.h socket.h uint16.h uint32.h ip6.h haveip6.h error.h
+	./compile socket_send6.c
+
 socket_tcp.o: \
 compile socket_tcp.c ndelay.h socket.h uint16.h
 	./compile socket_tcp.c
 
+socket_tcp6.o: \
+compile socket_tcp6.c ndelay.h socket.h uint16.h uint32.h haveip6.h
+	./compile socket_tcp6.c
+
 socket_udp.o: \
 compile socket_udp.c ndelay.h socket.h uint16.h
 	./compile socket_udp.c
 
+socket_udp6.o: \
+compile socket_udp6.c ndelay.h socket.h uint16.h uint32.h haveip6.h
+	./compile socket_udp6.c
+
+socket_noipv6.o: \
+compile socket_noipv6.c haveip6.h
+	./compile socket_noipv6.c
+
+socket_getifidx.o: \
+compile socket_getifidx.c socket.h uint16.h uint32.h haven2i.h
+	./compile socket_getifidx.c
+
+haven2i.h: \
+tryn2i.c choose compile load socket.lib haven2i.h1 haven2i.h2
+	cp /dev/null haven2i.h
+	./choose cL tryn2i haven2i.h1 haven2i.h2 socket > haven2i.h
+
 str_chr.o: \
 compile str_chr.c str.h
 	./compile str_chr.c
@@ -965,7 +1068,7 @@
 tdlookup.o: \
 compile tdlookup.c uint16.h open.h tai.h uint64.h cdb.h uint32.h \
 byte.h case.h dns.h stralloc.h gen_alloc.h iopause.h taia.h tai.h \
-taia.h seek.h response.h uint32.h
+taia.h seek.h response.h uint32.h ip6.h
 	./compile tdlookup.c
 
 timeoutread.o: \
@@ -979,10 +1082,10 @@
 	./compile timeoutwrite.c
 
 tinydns: \
-load tinydns.o server.o droproot.o tdlookup.o response.o qlog.o \
+load tinydns.o server.o iopause.o droproot.o tdlookup.o response.o qlog.o \
 prot.o dns.a libtai.a env.a cdb.a alloc.a buffer.a unix.a byte.a \
 socket.lib
-	./load tinydns server.o droproot.o tdlookup.o response.o \
+	./load tinydns server.o iopause.o droproot.o tdlookup.o response.o \
 	qlog.o prot.o dns.a libtai.a env.a cdb.a alloc.a buffer.a \
 	unix.a byte.a  `cat socket.lib`
 
@@ -1005,7 +1108,7 @@
 compile tinydns-data.c uint16.h uint32.h str.h byte.h fmt.h ip4.h \
 exit.h case.h scan.h buffer.h strerr.h getln.h buffer.h stralloc.h \
 gen_alloc.h cdb_make.h buffer.h uint32.h stralloc.h open.h dns.h \
-stralloc.h iopause.h taia.h tai.h uint64.h taia.h
+stralloc.h iopause.h taia.h tai.h uint64.h taia.h ip6.h
 	./compile tinydns-data.c
 
 tinydns-edit: \
@@ -1068,12 +1171,18 @@
 makelib buffer_read.o buffer_write.o error.o error_str.o ndelay_off.o \
 ndelay_on.o open_read.o open_trunc.o openreadclose.o readclose.o \
 seek_set.o socket_accept.o socket_bind.o socket_conn.o \
-socket_listen.o socket_recv.o socket_send.o socket_tcp.o socket_udp.o
+socket_listen.o socket_recv.o socket_send.o socket_tcp.o socket_udp.o \
+socket_udp6.o socket_getifidx.o socket_recv6.o socket_send6.o \
+socket_bind6.o socket_noipv6.o socket_tcp6.o socket_connect6.o \
+socket_accept6.o
 	./makelib unix.a buffer_read.o buffer_write.o error.o \
 	error_str.o ndelay_off.o ndelay_on.o open_read.o \
 	open_trunc.o openreadclose.o readclose.o seek_set.o \
 	socket_accept.o socket_bind.o socket_conn.o socket_listen.o \
-	socket_recv.o socket_send.o socket_tcp.o socket_udp.o
+	socket_recv.o socket_send.o socket_tcp.o socket_udp.o \
+	socket_udp6.o socket_getifidx.o socket_recv6.o socket_send6.o \
+	socket_bind6.o socket_noipv6.o socket_tcp6.o socket_connect6.o \
+	socket_accept6.o
 
 utime: \
 load utime.o byte.a
@@ -1084,10 +1193,10 @@
 	./compile utime.c
 
 walldns: \
-load walldns.o server.o response.o droproot.o qlog.o prot.o dd.o \
+load walldns.o server.o iopause.o response.o droproot.o qlog.o prot.o dd.o \
 dns.a env.a cdb.a alloc.a buffer.a unix.a byte.a socket.lib
-	./load walldns server.o response.o droproot.o qlog.o \
-	prot.o dd.o dns.a env.a cdb.a alloc.a buffer.a unix.a \
+	./load walldns server.o iopause.o response.o droproot.o qlog.o \
+	prot.o dd.o dns.a libtai.a env.a cdb.a alloc.a buffer.a unix.a \
 	byte.a  `cat socket.lib`
 
 walldns-conf: \
@@ -1104,3 +1213,14 @@
 compile walldns.c byte.h dns.h stralloc.h gen_alloc.h iopause.h \
 taia.h tai.h uint64.h taia.h dd.h response.h uint32.h
 	./compile walldns.c
+
+haveip6.h: \
+tryip6.c choose compile haveip6.h1 haveip6.h2
+	./choose c tryip6 haveip6.h1 haveip6.h2 > haveip6.h
+
+sockaddr_in6.h: \
+trysa6.c choose compile sockaddr_in6.h1 sockaddr_in6.h2 haveip6.h
+	./choose c trysa6 sockaddr_in6.h1 sockaddr_in6.h2 > sockaddr_in6.h
+
+clean:
+	rm -f `cat TARGETS`
diff -uNr djbdns-1.05/TARGETS djbdns-1.05-new/TARGETS
--- djbdns-1.05/TARGETS	2001-02-11 16:11:45.000000000 -0500
+++ djbdns-1.05-new/TARGETS	2003-09-16 10:09:36.000000000 -0400
@@ -102,6 +102,7 @@
 dns_dtda.o
 dns_ip.o
 dns_ipq.o
+dns_ipq6.o
 dns_mx.o
 dns_name.o
 dns_nd.o
@@ -180,6 +181,8 @@
 dnsip
 dnsipq.o
 dnsipq
+dnsip6q.o
+dnsip6q
 dnsname.o
 dnsname
 dnstxt.o
@@ -214,3 +217,25 @@
 it
 setup
 check
+scan_0x.o
+fmt_xlong.o
+ip6_scan.o
+ip6_fmt.o
+dnsip6.o
+dns_ip6.o
+dns_sortip6.o
+dnsip6
+dns_nd6.o
+socket_udp6.o
+socket_getifidx.o
+socket_bind6.o
+socket_noipv6.o
+socket_recv6.o
+socket_send6.o
+haveip6.h
+haven2i.h
+sockaddr_in6.h
+scan_xlong.o
+socket_accept6.o
+socket_connect6.o
+socket_tcp6.o
diff -uNr djbdns-1.05/axfr-get.c djbdns-1.05-new/axfr-get.c
--- djbdns-1.05/axfr-get.c	2001-02-11 16:11:45.000000000 -0500
+++ djbdns-1.05-new/axfr-get.c	2003-09-16 10:09:36.000000000 -0400
@@ -13,6 +13,7 @@
 #include "byte.h"
 #include "str.h"
 #include "ip4.h"
+#include "ip6.h"
 #include "timeoutread.h"
 #include "timeoutwrite.h"
 #include "dns.h"
@@ -217,6 +218,14 @@
     x_copy(buf,len,pos,data,4);
     if (!stralloc_catb(&line,ipstr,ip4_fmt(ipstr,data))) return 0;
   }
+  else if (byte_equal(data,2,DNS_T_AAAA)) {
+    char ipstr[IP6_FMT];
+    if (!stralloc_copys(&line,"3")) return 0;
+    if (!dns_domain_todot_cat(&line,d1)) return 0;
+    if (!stralloc_cats(&line,":")) return 0;
+    x_copy(buf,len,pos,data,16);
+    if (!stralloc_catb(&line,ipstr,ip6_fmt_flat(ipstr,data))) return 0;
+  }
   else {
     unsigned char ch;
     unsigned char ch2;
diff -uNr djbdns-1.05/dns.h djbdns-1.05-new/dns.h
--- djbdns-1.05/dns.h	2001-02-11 16:11:45.000000000 -0500
+++ djbdns-1.05-new/dns.h	2003-09-16 10:09:36.000000000 -0400
@@ -35,7 +35,8 @@
   struct taia deadline;
   unsigned int pos;
   const char *servers;
-  char localip[4];
+  char localip[16];
+  unsigned int scope_id;
   char qtype[2];
 } ;
 
@@ -43,6 +44,7 @@
 extern unsigned int dns_random(unsigned int);
 
 extern void dns_sortip(char *,unsigned int);
+extern void dns_sortip6(char *,unsigned int);
 
 extern void dns_domain_free(char **);
 extern int dns_domain_copy(char **,const char *);
@@ -68,6 +70,8 @@
 
 extern int dns_ip4_packet(stralloc *,const char *,unsigned int);
 extern int dns_ip4(stralloc *,const stralloc *);
+extern int dns_ip6_packet(stralloc *,char *,unsigned int);
+extern int dns_ip6(stralloc *,stralloc *);
 extern int dns_name_packet(stralloc *,const char *,unsigned int);
 extern void dns_name4_domain(char *,const char *);
 #define DNS_NAME4_DOMAIN 31
@@ -80,5 +84,10 @@
 extern int dns_resolvconfrewrite(stralloc *);
 extern int dns_ip4_qualify_rules(stralloc *,stralloc *,const stralloc *,const stralloc *);
 extern int dns_ip4_qualify(stralloc *,stralloc *,const stralloc *);
+extern int dns_ip6_qualify_rules(stralloc *,stralloc *,const stralloc *,const stralloc *);
+extern int dns_ip6_qualify(stralloc *,stralloc *,const stralloc *);
+
+extern int dns_name6_domain(char *,char *);
+#define DNS_NAME6_DOMAIN (4*16+10)
 
 #endif
diff -uNr djbdns-1.05/dns_ip6.c djbdns-1.05-new/dns_ip6.c
--- djbdns-1.05/dns_ip6.c	1969-12-31 19:00:00.000000000 -0500
+++ djbdns-1.05-new/dns_ip6.c	2003-09-16 10:09:36.000000000 -0400
@@ -0,0 +1,103 @@
+#include "stralloc.h"
+#include "uint16.h"
+#include "byte.h"
+#include "dns.h"
+#include "ip4.h"
+#include "ip6.h"
+
+static int dns_ip6_packet_add(stralloc *out,char *buf,unsigned int len)
+{
+  unsigned int pos;
+  char header[16];
+  uint16 numanswers;
+  uint16 datalen;
+
+  pos = dns_packet_copy(buf,len,0,header,12); if (!pos) return -1;
+  uint16_unpack_big(header + 6,&numanswers);
+  pos = dns_packet_skipname(buf,len,pos); if (!pos) return -1;
+  pos += 4;
+
+  while (numanswers--) {
+    pos = dns_packet_skipname(buf,len,pos); if (!pos) return -1;
+    pos = dns_packet_copy(buf,len,pos,header,10); if (!pos) return -1;
+    uint16_unpack_big(header + 8,&datalen);
+    if (byte_equal(header,2,DNS_T_AAAA)) {
+      if (byte_equal(header + 2,2,DNS_C_IN))
+        if (datalen == 16) {
+	  if (!dns_packet_copy(buf,len,pos,header,16)) return -1;
+	  if (!stralloc_catb(out,header,16)) return -1;
+	}
+    } else if (byte_equal(header,2,DNS_T_A))
+      if (byte_equal(header + 2,2,DNS_C_IN))
+        if (datalen == 4) {
+	  byte_copy(header,12,V4mappedprefix);
+	  if (!dns_packet_copy(buf,len,pos,header+12,4)) return -1;
+	  if (!stralloc_catb(out,header,16)) return -1;
+	}
+    pos += datalen;
+  }
+
+  dns_sortip6(out->s,out->len);
+  return 0;
+}
+
+int dns_ip6_packet(stralloc *out,char *buf,unsigned int len) {
+  if (!stralloc_copys(out,"")) return -1;
+  return dns_ip6_packet_add(out,buf,len);
+}
+
+static char *q = 0;
+
+int dns_ip6(stralloc *out,stralloc *fqdn)
+{
+  unsigned int i;
+  char code;
+  char ch;
+  char ip[16];
+
+  if (!stralloc_copys(out,"")) return -1;
+  if (!stralloc_readyplus(fqdn,1)) return -1;
+  fqdn->s[fqdn->len]=0;
+  if ((i=ip6_scan(fqdn->s,ip))) {
+    if (fqdn->s[i]) return -1;
+    stralloc_copyb(out,ip,16);
+    return 0;
+  }
+  code = 0;
+  for (i = 0;i <= fqdn->len;++i) {
+    if (i < fqdn->len)
+      ch = fqdn->s[i];
+    else
+      ch = '.';
+
+    if ((ch == '[') || (ch == ']')) continue;
+    if (ch == '.') {
+      if (!stralloc_append(out,&code)) return -1;
+      code = 0;
+      continue;
+    }
+    if ((ch >= '0') && (ch <= '9')) {
+      code *= 10;
+      code += ch - '0';
+      continue;
+    }
+
+    if (!dns_domain_fromdot(&q,fqdn->s,fqdn->len)) return -1;
+    if (!stralloc_copys(out,"")) return -1;
+    if (dns_resolve(q,DNS_T_AAAA) != -1)
+      if (dns_ip6_packet_add(out,dns_resolve_tx.packet,dns_resolve_tx.packetlen) != -1) {
+	dns_transmit_free(&dns_resolve_tx);
+	dns_domain_free(&q);
+      }
+    if (!dns_domain_fromdot(&q,fqdn->s,fqdn->len)) return -1;
+    if (dns_resolve(q,DNS_T_A) != -1)
+      if (dns_ip6_packet_add(out,dns_resolve_tx.packet,dns_resolve_tx.packetlen) != -1) {
+	dns_transmit_free(&dns_resolve_tx);
+	dns_domain_free(&q);
+      }
+    return out->a>0?0:-1;
+  }
+
+  out->len &= ~3;
+  return 0;
+}
diff -uNr djbdns-1.05/dns_ipq6.c djbdns-1.05-new/dns_ipq6.c
--- djbdns-1.05/dns_ipq6.c	1969-12-31 19:00:00.000000000 -0500
+++ djbdns-1.05-new/dns_ipq6.c	2003-09-16 10:09:36.000000000 -0400
@@ -0,0 +1,72 @@
+#include "stralloc.h"
+#include "case.h"
+#include "byte.h"
+#include "str.h"
+#include "dns.h"
+
+static int doit(stralloc *work,const char *rule)
+{
+  char ch;
+  unsigned int colon;
+  unsigned int prefixlen;
+
+  ch = *rule++;
+  if ((ch != '?') && (ch != '=') && (ch != '*') && (ch != '-')) return 1;
+  colon = str_chr(rule,':');
+  if (!rule[colon]) return 1;
+
+  if (work->len < colon) return 1;
+  prefixlen = work->len - colon;
+  if ((ch == '=') && prefixlen) return 1;
+  if (case_diffb(rule,colon,work->s + prefixlen)) return 1;
+  if (ch == '?') {
+    if (byte_chr(work->s,prefixlen,'.') < prefixlen) return 1;
+    if (byte_chr(work->s,prefixlen,':') < prefixlen) return 1;
+    if (byte_chr(work->s,prefixlen,'[') < prefixlen) return 1;
+    if (byte_chr(work->s,prefixlen,']') < prefixlen) return 1;
+  }
+
+  work->len = prefixlen;
+  if (ch == '-') work->len = 0;
+  return stralloc_cats(work,rule + colon + 1);
+}
+
+int dns_ip6_qualify_rules(stralloc *out,stralloc *fqdn,const stralloc *in,const stralloc *rules)
+{
+  unsigned int i;
+  unsigned int j;
+  unsigned int plus;
+  unsigned int fqdnlen;
+
+  if (!stralloc_copy(fqdn,in)) return -1;
+
+  for (j = i = 0;j < rules->len;++j)
+    if (!rules->s[j]) {
+      if (!doit(fqdn,rules->s + i)) return -1;
+      i = j + 1;
+    }
+
+  fqdnlen = fqdn->len;
+  plus = byte_chr(fqdn->s,fqdnlen,'+');
+  if (plus >= fqdnlen)
+    return dns_ip6(out,fqdn);
+
+  i = plus + 1;
+  for (;;) {
+    j = byte_chr(fqdn->s + i,fqdnlen - i,'+');
+    byte_copy(fqdn->s + plus,j,fqdn->s + i);
+    fqdn->len = plus + j;
+    if (dns_ip6(out,fqdn) == -1) return -1;
+    if (out->len) return 0;
+    i += j;
+    if (i >= fqdnlen) return 0;
+    ++i;
+  }
+}
+
+int dns_ip6_qualify(stralloc *out,stralloc *fqdn,const stralloc *in)
+{
+  static stralloc rules;
+  if (dns_resolvconfrewrite(&rules) == -1) return -1;
+  return dns_ip6_qualify_rules(out,fqdn,in,&rules);
+}
diff -uNr djbdns-1.05/dns_name.c djbdns-1.05-new/dns_name.c
--- djbdns-1.05/dns_name.c	2001-02-11 16:11:45.000000000 -0500
+++ djbdns-1.05-new/dns_name.c	2003-09-16 10:09:36.000000000 -0400
@@ -2,6 +2,7 @@
 #include "uint16.h"
 #include "byte.h"
 #include "dns.h"
+#include "ip6.h"
 
 static char *q = 0;
 
@@ -46,3 +47,17 @@
   dns_domain_free(&q);
   return 0;
 }
+
+int dns_name6(stralloc *out,char ip[16])
+{
+  char name[DNS_NAME6_DOMAIN];
+
+  if (ip6_isv4mapped(ip))
+    return dns_name4(out,ip+12);
+  dns_name6_domain(name,ip);
+  if (dns_resolve(name,DNS_T_PTR) == -1) return -1;
+  if (dns_name_packet(out,dns_resolve_tx.packet,dns_resolve_tx.packetlen) == -1) return -1;
+  dns_transmit_free(&dns_resolve_tx);
+  dns_domain_free(&q);
+  return 0;
+}
diff -uNr djbdns-1.05/dns_nd6.c djbdns-1.05-new/dns_nd6.c
--- djbdns-1.05/dns_nd6.c	1969-12-31 19:00:00.000000000 -0500
+++ djbdns-1.05-new/dns_nd6.c	2003-09-16 10:09:36.000000000 -0400
@@ -0,0 +1,28 @@
+#include "byte.h"
+#include "fmt.h"
+#include "dns.h"
+
+/* RFC1886:
+ *   4321:0:1:2:3:4:567:89ab
+ * ->
+ *   b.a.9.8.7.6.5.0.4.0.0.0.3.0.0.0.2.0.0.0.1.0.0.0.0.0.0.0.1.2.3.4.IP6.INT.
+ */
+
+unsigned int mkint(unsigned char a,unsigned char b) {
+  return ((unsigned int)a << 8) + (unsigned int)b;
+}
+
+int dns_name6_domain(char name[DNS_NAME6_DOMAIN],char ip[16])
+{
+  unsigned int j;
+
+  for (j=0; j<16; j++) {
+    name[j*4]=1;
+    name[j*4+1]=tohex(ip[15-j] & 15);
+    name[j*4+2]=1;
+    name[j*4+3]=tohex((unsigned char)ip[15-j] >> 4);
+  }
+  byte_copy(name + 4*16,9,"\3ip6\3int\0");
+  return 4*16+9;
+}
+
diff -uNr djbdns-1.05/dns_rcip.c djbdns-1.05-new/dns_rcip.c
--- djbdns-1.05/dns_rcip.c	2001-02-11 16:11:45.000000000 -0500
+++ djbdns-1.05-new/dns_rcip.c	2003-09-16 10:09:36.000000000 -0400
@@ -2,12 +2,13 @@
 #include "openreadclose.h"
 #include "byte.h"
 #include "ip4.h"
+#include "ip6.h"
 #include "env.h"
 #include "dns.h"
 
 static stralloc data = {0};
 
-static int init(char ip[64])
+static int init(char ip[256])
 {
   int i;
   int j;
@@ -20,10 +21,10 @@
       if (*x == '.')
 	++x;
       else {
-        i = ip4_scan(x,ip + iplen);
+        i = ip6_scan(x,ip + iplen);
 	if (!i) break;
 	x += i;
-	iplen += 4;
+	iplen += 16;
       }
     }
 
@@ -40,10 +41,8 @@
             while ((data.s[i] == ' ') || (data.s[i] == '\t'))
               ++i;
             if (iplen <= 60)
-              if (ip4_scan(data.s + i,ip + iplen)) {
-		if (byte_equal(ip + iplen,4,"\0\0\0\0"))
-		  byte_copy(ip + iplen,4,"\177\0\0\1");
-                iplen += 4;
+              if (ip6_scan(data.s + i,ip + iplen)) {
+                iplen += 16;
 	      }
           }
           i = j + 1;
@@ -52,19 +51,19 @@
   }
 
   if (!iplen) {
-    byte_copy(ip,4,"\177\0\0\1");
-    iplen = 4;
+    byte_copy(ip,16,"\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\1");
+    iplen = 16;
   }
-  byte_zero(ip + iplen,64 - iplen);
+  byte_zero(ip + iplen,256 - iplen);
   return 0;
 }
 
 static int ok = 0;
 static unsigned int uses;
 static struct taia deadline;
-static char ip[64]; /* defined if ok */
+static char ip[256]; /* defined if ok */
 
-int dns_resolvconfip(char s[64])
+int dns_resolvconfip(char s[256])
 {
   struct taia now;
 
@@ -81,6 +80,6 @@
   }
 
   --uses;
-  byte_copy(s,64,ip);
+  byte_copy(s,256,ip);
   return 0;
 }
diff -uNr djbdns-1.05/dns_resolve.c djbdns-1.05-new/dns_resolve.c
--- djbdns-1.05/dns_resolve.c	2001-02-11 16:11:45.000000000 -0500
+++ djbdns-1.05-new/dns_resolve.c	2003-09-16 10:09:36.000000000 -0400
@@ -2,6 +2,7 @@
 #include "taia.h"
 #include "byte.h"
 #include "dns.h"
+#include "ip6.h"
 
 struct dns_transmit dns_resolve_tx = {0};
 
@@ -9,12 +10,12 @@
 {
   struct taia stamp;
   struct taia deadline;
-  char servers[64];
+  char servers[256];
   iopause_fd x[1];
   int r;
 
   if (dns_resolvconfip(servers) == -1) return -1;
-  if (dns_transmit_start(&dns_resolve_tx,servers,1,q,qtype,"\0\0\0\0") == -1) return -1;
+  if (dns_transmit_start(&dns_resolve_tx,servers,1,q,qtype,V6any) == -1) return -1;
 
   for (;;) {
     taia_now(&stamp);
diff -uNr djbdns-1.05/dns_sortip6.c djbdns-1.05-new/dns_sortip6.c
--- djbdns-1.05/dns_sortip6.c	1969-12-31 19:00:00.000000000 -0500
+++ djbdns-1.05-new/dns_sortip6.c	2003-09-16 10:09:36.000000000 -0400
@@ -0,0 +1,20 @@
+#include "byte.h"
+#include "dns.h"
+
+/* XXX: sort servers by configurable notion of closeness? */
+/* XXX: pay attention to competence of each server? */
+
+void dns_sortip6(char *s,unsigned int n)
+{
+  unsigned int i;
+  char tmp[16];
+
+  n >>= 4;
+  while (n > 1) {
+    i = dns_random(n);
+    --n;
+    byte_copy(tmp,16,s + (i << 4));
+    byte_copy(s + (i << 4),16,s + (n << 4));
+    byte_copy(s + (n << 4),16,tmp);
+  }
+}
diff -uNr djbdns-1.05/dns_transmit.c djbdns-1.05-new/dns_transmit.c
--- djbdns-1.05/dns_transmit.c	2001-02-11 16:11:45.000000000 -0500
+++ djbdns-1.05-new/dns_transmit.c	2003-09-16 10:09:36.000000000 -0400
@@ -7,6 +7,7 @@
 #include "byte.h"
 #include "uint16.h"
 #include "dns.h"
+#include "ip6.h"
 
 static int serverwantstcp(const char *buf,unsigned int len)
 {
@@ -85,9 +86,9 @@
   int j;
 
   for (j = 0;j < 10;++j)
-    if (socket_bind4(d->s1 - 1,d->localip,1025 + dns_random(64510)) == 0)
+    if (socket_bind6(d->s1 - 1,d->localip,1025 + dns_random(64510),d->scope_id) == 0)
       return 0;
-  if (socket_bind4(d->s1 - 1,d->localip,0) == 0)
+  if (socket_bind6(d->s1 - 1,d->localip,0,d->scope_id) == 0)
     return 0;
   return -1;
 }
@@ -102,16 +103,16 @@
 
   while (d->udploop < 4) {
     for (;d->curserver < 16;++d->curserver) {
-      ip = d->servers + 4 * d->curserver;
-      if (byte_diff(ip,4,"\0\0\0\0")) {
+      ip = d->servers + 16 * d->curserver;
+      if (byte_diff(ip,16,V6any)) {
 	d->query[2] = dns_random(256);
 	d->query[3] = dns_random(256);
   
-        d->s1 = 1 + socket_udp();
+        d->s1 = 1 + socket_udp6();
         if (!d->s1) { dns_transmit_free(d); return -1; }
 	if (randombind(d) == -1) { dns_transmit_free(d); return -1; }
 
-        if (socket_connect4(d->s1 - 1,ip,53) == 0)
+        if (socket_connect6(d->s1 - 1,ip,53,d->scope_id) == 0)
           if (send(d->s1 - 1,d->query + 2,d->querylen - 2,0) == d->querylen - 2) {
             struct taia now;
             taia_now(&now);
@@ -153,19 +154,19 @@
   packetfree(d);
 
   for (;d->curserver < 16;++d->curserver) {
-    ip = d->servers + 4 * d->curserver;
-    if (byte_diff(ip,4,"\0\0\0\0")) {
+    ip = d->servers + 16 * d->curserver;
+    if (byte_diff(ip,16,V6any)) {
       d->query[2] = dns_random(256);
       d->query[3] = dns_random(256);
 
-      d->s1 = 1 + socket_tcp();
+      d->s1 = 1 + socket_tcp6();
       if (!d->s1) { dns_transmit_free(d); return -1; }
       if (randombind(d) == -1) { dns_transmit_free(d); return -1; }
   
       taia_now(&now);
       taia_uint(&d->deadline,10);
       taia_add(&d->deadline,&d->deadline,&now);
-      if (socket_connect4(d->s1 - 1,ip,53) == 0) {
+      if (socket_connect6(d->s1 - 1,ip,53,d->scope_id) == 0) {
         d->tcpstate = 2;
         return 0;
       }
@@ -193,7 +194,7 @@
   return thistcp(d);
 }
 
-int dns_transmit_start(struct dns_transmit *d,const char servers[64],int flagrecursive,const char *q,const char qtype[2],const char localip[4])
+int dns_transmit_start(struct dns_transmit *d,const char servers[256],int flagrecursive,const char *q,const char qtype[2],const char localip[16])
 {
   unsigned int len;
 
@@ -213,7 +214,7 @@
 
   byte_copy(d->qtype,2,qtype);
   d->servers = servers;
-  byte_copy(d->localip,4,localip);
+  byte_copy(d->localip,16,localip);
 
   d->udploop = flagrecursive ? 1 : 0;
 
diff -uNr djbdns-1.05/dnscache-conf.c djbdns-1.05-new/dnscache-conf.c
--- djbdns-1.05/dnscache-conf.c	2001-02-11 16:11:45.000000000 -0500
+++ djbdns-1.05-new/dnscache-conf.c	2003-09-16 10:09:36.000000000 -0400
@@ -136,6 +136,7 @@
   seed_addtime(); start("root/ip/127.0.0.1"); finish();
   seed_addtime(); perm(0600);
   seed_addtime(); makedir("root/servers");
+  seed_addtime(); makedir("root/caches");
   seed_addtime(); perm(02755);
   seed_addtime(); start("root/servers/@");
   buffer_init(&ssrootservers,buffer_unixread,fdrootservers,rootserversbuf,sizeof rootserversbuf);
